Unit DE32R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE28RS_p, UTDE12_p;

procedure DE32R(F :Proc_F_DE; M :Integer; IORDER :Integer; XN :Real;
                var YN :Array of Real; HMIN :Real; EPS :Real; P :Real;
                var H :Real; var DF :Array of Real;
                var X :Array of Real; var Y :Array of Real;
                var BUL :Boolean; var RS :Array of Real;
                var RF :Array of Real; var R :Array of Real;
                var IERR :Integer);

implementation

procedure DE32R(F :Proc_F_DE; M :Integer; IORDER :Integer; XN :Real;
                var YN :Array of Real; HMIN :Real; EPS :Real; P :Real;
                var H :Real; var DF :Array of Real;
                var X :Array of Real; var Y :Array of Real;
                var BUL :Boolean; var RS :Array of Real;
                var RF :Array of Real; var R :Array of Real;
                var IERR :Integer);
var
IO,I,J,K,K1,L,J1 :Integer;
R1 :Real;
BUL1 :Boolean;
C :Array [0..9] of Real;
D :Array [0..44] of Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18;
begin
{   DATA  FORTRAN  }
D[0] := 1.0;
D[1] := 1.0;
D[2] := -2.0;
D[3] := 1.0;
D[4] := -3.0;
D[5] := 3.0;
D[6] := 1.0;
D[7] := -4.0;
D[8] := 6.0;
D[9] := -4.0;
D[10] := 1.0;
D[11] := -5.0;
D[12] := 10.0;
D[13] := -10.0;
D[14] := 5.0;
D[15] := 1.0;
D[16] := -6.0;
D[17] := 15.0;
D[18] := -20.0;
D[19] := 15.0;
D[20] := -6.0;
D[21] := 1.0;
D[22] := -7.0;
D[23] := 21.0;
D[24] := -35.0;
D[25] := 35.0;
D[26] := -21.0;
D[27] := 7.0;
D[28] := 1.0;
D[29] := -8.0;
D[30] := 28.0;
D[31] := -56.0;
D[32] := 70.0;
D[33] := -56.0;
D[34] := 28.0;
D[35] := -8.0;
D[36] := 1.0;
D[37] := -9.0;
D[38] := 36.0;
D[39] := -84.0;
D[40] := 126.0;
D[41] := -126.0;
D[42] := 84.0;
D[43] := -36.0;
D[44] := 9.0;
C[0] := 1.0;
C[1] := 0.5;
C[2] := 0.416667;
C[3] := 0.375;
C[4] := 0.348611;
C[5] := 0.329861;
C[6] := 0.315592;
C[7] := 0.305266;
C[8] := 0.294868;
C[9] := 0.149189;
IERR := 0;
IO := IORDER;
BUL1 := False;
if ( IORDER <= 10 ) 
 then goto _1;
IERR := 1;
IO := 10;
_1:
for I:=1 to M do
 begin
  Y[(I-1)+0*M] := YN[I-1];
_2:
 end;
X[0] := XN;
F(X[0],Y[0+0*M],DF[0+0*M],M);
_3:
for I:=1 to M do
 begin
  DF[(I-1)+0*M] := DF[(I-1)+0*M]*H;
  RS[I-1] := DF[(I-1)+0*M];
_4:
 end;
if ( IORDER = 1 ) 
 then goto _18;
for K:=2 to IO do
 begin
  X[K-1] := X[K-2]+H;
_5:
 end;
for J:=2 to IO do
 begin
  J1 := J-1;
  for K:=2 to J do
   begin
    K1 := K-1;
    for I:=1 to M do
     begin
      Y[(I-1)+(K-1)*M] := Y[(I-1)+(K1-1)*M];
      for L:=1 to J1 do
       begin
        Y[(I-1)+(K-1)*M] := Y[(I-1)+(K-1)*M]+DF[(I-1)+(L-1)*M]*C[L-1];
_6:
       end;
_7:
     end;
    F(X[K-1],Y[0+(K-1)*M],RF,M);
    for I:=1 to M do
     begin
      RF[I-1] := RF[I-1]*H;
_8:
     end;
    if ( K = J ) 
     then J1 := J;
    DE28RS(M,J1,RF,DF,R);
_9:
   end;
  for I:=1 to M do
   begin
    for L:=2 to J do
     begin
      R1 := 0.0;
      for K:=L to J do
       begin
        K1 := (J-1)*(J-2) div 2+K-L+1;
        R1 := R1+DF[(I-1)+(K-1)*M]*D[K1-1];
_10:
       end;
      DF[(I-1)+(L-1)*M] := R1;
_11:
     end;
    DF[(I-1)+0*M] := RS[I-1];
_12:
   end;
_13:
 end;
for I:=1 to M do
 begin
  R[I-1] := DF[(I-1)+(IO-1)*M];
  if ( Abs(Y[(I-1)+(IO-1)*M]) <= P ) 
   then goto _14;
  R[I-1] := R[I-1]/Y[(I-1)+(IO-1)*M];
_14:
  R[I-1] := R[I-1]*C[IO-1];
  if ( Abs(R[I-1]) > EPS ) 
   then goto _16;
_15:
 end;
goto _18;
_16:
if ( not BUL1 ) 
 then goto _17;
IERR := 65;
goto _18;
_17:
H := H*0.5;
BUL := False;
if ( Abs(H) > Abs(HMIN) ) 
 then goto _3;
H := Sign(HMIN,H);
BUL1 := True;
goto _3;
_18:
if ( IERR <> 0 ) 
 then UTDE12(IERR,32);
end;

end.
